<template>
  <v-container fluid>
    <v-layout wrap v-if="user">
      <v-flex md4 class="pa-0 ma-0 hidden-xs-only">
        <ShowList
          :taskList="user.taskLists"
          :current="list ? list.id : 0"
          v-on:load="loadTaskFromList($event)"
          v-on:addList="listModal(null)"
          v-on:deleteList="showListConfirmation($event)"
          v-on:editList="listModal($event)"
        />
      </v-flex>
      <v-flex xs12 md8 class="pa-0 ma-0 ">
        <ShowTasks
          v-if="list"
          :list="list"
          v-on:deleteTask="showTaskConfirmation($event)"
          v-on:editTask="taskModal($event)"
          v-on:addTaskModal="taskModal(null)"
          v-on:askAction="askActionModal($event)"
        />
      </v-flex>
      <v-flex v-if="!list" xs12 class="hidden-sm-and-up">
        <v-card class="pt-0 ma-0 my-3 "
          v-for="item in user.taskLists"
          :key="item.id"
          :class="[item.color]">
          <v-card-title @click="loadTaskFromList(item)">
            <v-layout wrap>
              <v-flex xs12 md12 class="headline">
                <v-list-tile-content>
                  <v-list-tile-title>{{ item.title }}</v-list-tile-title>
                </v-list-tile-content>
              </v-flex>
              <v-flex xs12 class="subheading">
                Completion: <b>{{(item.nbCompletedTask / (item.nbTask === 0 ? 1: item.nbTask) * 100).toFixed(0) + ' %'}}</b>&nbsp;{{ '(' + item.nbCompletedTask + '/' + item.nbTask + ')' }}
              </v-flex>
            </v-layout>
          </v-card-title>
        </v-card>
        <v-card class="pt-0 my-3 mx-3 ">
          <v-card-title>
            <v-spacer></v-spacer>
            <v-btn color="error black--text" @click="listModal(null)" type="button">Create list</v-btn>
            <v-spacer></v-spacer>
          </v-card-title>
        </v-card>
      </v-flex>
      <v-btn
        v-if="list"
        fixed
        dark
        fab
        bottom
        class="hidden-sm-and-up"
        left
        color="pink"
        @click="$store.commit('addTask')"
        style="z-index:0">
        <v-icon>add</v-icon>
      </v-btn>
    <AddTask
      :list=list
      :task=task
      :dialog="addTaskDialog"
      v-on:cancel="addTaskDialog = false"
      v-on:refreshList="refreshListTask($event)"/>
    <AddList
      :list=listToAdd
      :dialog="addListDialog"
      v-on:cancel="addListDialog = false"
      v-on:refreshList="refreshListTask($event)"/>
    <ConfirmationModal
      :header="{title: 'Confirmation', icon: 'warning'}"
      text="Do you really want to delete the task ?"
      :buttons="{cancel: 'Cancel', success: 'Yes'}"
      :dialog="confirmationTaskDialog"
      v-on:cancel="confirmationTaskDialog = false"
      v-on:success="deleteTask()"/>
    <ConfirmationModal
      :header="{title: 'Confirmation', icon: 'warning'}"
      text="Do you really want to delete the list ?"
      :buttons="{cancel: 'Cancel', success: 'Yes'}"
      :dialog="confirmationListDialog"
      v-on:cancel="confirmationListDialog = false"
      v-on:success="deleteList()"/>
    <ActionsModal
      v-on:cancel="cancelAskActions()"
      v-on:edit="taskModal(askActionTask)"
      v-on:delete="showTaskConfirmation(askActionTask)"
      :dialog="askActionDialog"/>
    </v-layout>
  </v-container>
</template>

<script>

import TaskService from '@/services/TaskService'
import UserService from '@/services/UserService'
import ListService from '@/services/ListService'
import ErrorService from '@/services/ErrorService'

import ShowList from '@/components/ShowList'
import ShowTasks from '@/components/ShowTasks'
import AddTask from '@/components/Form/Task.add'
import AddList from '@/components/Form/List.add'
import ConfirmationModal from '@/components/Modals/ConfirmationModal'
import ActionsModal from '@/components/Modals/ActionsModal'

import { mapGetters } from 'vuex'

export default {
  components: {
    ShowList,
    ShowTasks,
    AddTask,
    AddList,
    ConfirmationModal,
    ActionsModal
  },
  data: () => ({
    errorService: new ErrorService(),
    userService: new UserService(),
    listService: new ListService(),
    taskService: new TaskService(),
    user: null,
    list: null,
    listToAdd: null,
    addTaskDialog: false,
    task: null,
    addListDialog: false,
    confirmationTaskDialog: false,
    confirmationListDialog: false,
    taskToDelete: null,
    listToDelete: null,
    askActionDialog: false,
    askActionTask: null
  }),
  computed: {
    ...mapGetters({
      loadNewList: 'loadNewList',
      listToLoad: 'listToLoad',
      addList: 'addList',
      listToEdit: 'listToEdit',
      editList: 'editList',
      addTask: 'addTask',
      deleteCurrent: 'deleteCurrent'
    })
  },
  watch: {
    deleteCurrent: function (val) {
      if (val) {
        this.$store.commit('deleteCurrent', false)
        this.showListConfirmation(this.listToLoad)
      }
    },
    loadNewList: function (val) {
      if (val) {
        this.loadTaskFromList(this.listToLoad)
      }
    },
    addList: function (val) {
      if (val) {
        this.listModal(null)
        this.$store.commit('addList', false)
      }
    },
    editList: function (val) {
      if (val) {
        this.listModal(this.listToEdit)
        this.$store.commit('listEdited')
      }
    },
    addTask: function (val) {
      if (val) {
        this.taskModal(null)
        this.$store.commit('addTask')
      }
    }
  },
  mounted () {
    this.$store.commit('loading', true)
    this.userService.getUser().then((response) => {
      this.user = response.data
      if (this.user.taskLists.length && this.user.taskLists.length > 0) {
        this.$store.commit('user/updateList', this.user.taskLists)
        this.$store.commit('showDescription', response.data.showDescription)
        this.$store.commit('loading', false)
      } else {
        this.$store.commit('user/updateList', null)
        this.$store.commit('loading', false)
      }
    }, (error) => {
      this.errorService.getServeurNotif(error.status, error.bodyText)
      this.$store.commit('loading', false)
    })
  },
  methods: {
    loadTaskFromList: function (event) {
      this.$store.commit('loading', true)
      this.$store.commit('newListLoaded', event)
      this.listService.getList(event.id).then((response) => {
        this.list = response.data
        this.list.class = 'headline ' + this.list.color
        if (this.list.tasks.length > 0) {
          this.list.tasks.forEach(task => {
            task.listId = event.id
          })
        }
        this.$store.commit('loading', false)
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.commit('loading', false)
      })
    },
    refreshListTask: function (event) {
      if (event !== undefined) {
        this.list = {
          id: event
        }
      }
      this.$store.commit('loading', true)
      this.addListDialog = false
      this.addTaskDialog = false
      this.userService.getUser().then((response) => {
        this.user = response.data
        if (this.user.taskLists.length > 0) {
          this.$store.commit('user/updateList', this.user.taskLists)
          this.user.taskLists.forEach(elem => {
            elem.class = 'headline ' + elem.color
            if (this.list && (elem.id === this.list.id)) {
              this.loadTaskFromList(elem)
            }
            this.$store.commit('loading', false)
          })
        } else {
          this.$store.commit('user/updateList', null)
          this.$store.commit('loading', false)
        }
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.commit('loading', false)
      })
    },
    taskModal: function (event) {
      this.askActionDialog = false
      this.addTaskDialog = true
      if (event === null) {
        this.task = {
          id: -1
        }
      } else {
        this.task = event
      }
    },
    listModal: function (event) {
      this.addListDialog = true
      if (event === null) {
        this.listToAdd = {
          id: -1
        }
      } else {
        this.listToAdd = event
      }
    },
    showTaskConfirmation: function (event) {
      this.askActionDialog = false
      this.taskToDelete = event
      this.confirmationTaskDialog = true
    },
    showListConfirmation: function (event) {
      this.listToDelete = event
      this.confirmationListDialog = true
    },
    deleteTask: function () {
      this.$store.commit('loading', true)
      this.taskService.removeTask(this.list.id, this.taskToDelete.id).then((response) => {
        this.confirmationTaskDialog = false
        this.$store.commit('loading', false)
        this.refreshListTask()
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.dispatch('alert/error', { content: 'Impossible to delete task. Please try again later.' })
        this.$store.commit('loading', false)
        this.confirmationTaskDialog = false
      })
    },
    deleteList: function (event) {
      this.$store.commit('loading', true)
      this.listService.removeList(this.listToDelete.id).then((response) => {
        this.list = null
        this.$store.commit('loading', false)
        this.confirmationListDialog = false
        this.$store.commit('newListLoaded', null)
        this.refreshListTask()
      }, (error) => {
        this.errorService.getServeurNotif(error.status, error.bodyText)
        this.$store.dispatch('alert/error', { content: 'Impossible to delete list. Please try again later.' })
        this.$store.commit('loading', false)
        this.confirmationListDialog = false
      })
    },
    askActionModal: function (task) {
      this.askActionTask = task
      this.askActionDialog = true
    },
    cancelAskActions: function () {
      this.askActionTask = null
      this.askActionDialog = false
    }
  }
}
</script>
